
require("love.filesystem")

local generation = require("generation/main")

if not producer then producer = love.thread.getThread("map") end

if producer then
	producer:set("action","creating map")
	local xwide,yhigh = producer:get("xw"),producer:get("yh")
	local map = generation(xwide,yhigh)
	producer:set("action","converting map")
	local s = ""
	for i = 1,yhigh do
		for j = 1,xwide do
			producer:set(j.."x"..i,map[i][j])
		end
	end
	producer:set("action","done")
	producer:set("xn",1)
	producer:set("yn",1)
	producer:set("xp",xwide)
	producer:set("yp",yhigh)
else
	local loader
	local self = {}

	local done = 0
	local actions = {}
	local map = {}

	local doneFunc

	self.start = function(doneF,xw,yh)
		if not loader then loader = love.thread.newThread("map","generation/loader.lua") end
		loader:set("xw",xw)
		loader:set("yh",yh)
		loader:start()
		doneFunc = doneF
	end
	self.getDone = function()
		return done * 100
	end
	self.getAction = function()
		return actions[#actions]
	end
	self.getActions = function()
		return actions
	end
	self.update = function(dt)
		local err = loader:get("error")
		if err then print(err) end
		local yp = loader:get("yp")
		if yp then
			map.minx = loader:get("xn")
			map.maxx = loader:get("xp")
			map.miny = loader:get("yn")
			map.maxy = yp
			for i = map.minx,map.maxx do
				map[i] = {}
				for j = map.miny,map.maxy do
					map[i][j] = loader:get(i.."x"..j)
				end
			end
		end
		local a = loader:get("action")
		if a then
			if a == "done" then
				if doneFunc then
					doneFunc(map)
				end
			end
			table.insert(actions,a)
		end
		local d = loader:get("done")
		if d then
			done = d
		end
	end

	return self
end
